#! /bin/sh

#
# Copyright (c) 1997 Picture Elements Inc.
#	Stephen Williams <steve@picturel.com>
#
#    This source code is free software; you can redistribute it
#    and/or modify it in source code form under the terms of the GNU
#    Library General Public License as published by the Free Software
#    Foundation; either version 2 of the License, or (at your option)
#    any later version. In order to redistribute the software in
#    binary form, you will need a Picture Elements Binary Software
#    License.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Library General Public License for more details.
#
#    You should have received a copy of the GNU Library General Public
#    License along with this program; if not, write to the Free
#    Software Foundation, Inc.,
#    59 Temple Place - Suite 330
#    Boston, MA 02111-1307, USA
#
#    You should also have recieved a copy of the Picture Elements
#    Binary Software License offer along with the source. This offer
#    allows you to obtain the right to redistribute the software in
#    binary (compiled) form. If you have not received it, contact
#    Picture Elements, Inc.,
#    777 Panoramic Way
#    Berkeley, CA 94704.
#
# --

#
# There are some programs/source that needs to be configured for the
# characteristics of the host/build/target machine. These directories
# have configure.in files that autoconf uses to generate configure
# scripts. This program runs through the source directory looking for
# the configure.in files and running autoconf.
#

self_dir=`dirname $0`
echo "Generating configuration files for $self_dir"
cd $self_dir

find source -name configure.in -print | while read configure
    do
	dir=`dirname $configure`
	echo "...$dir/configure"
	( cd $dir ; autoconf )
    done

