Summary: Assembler and linker tools for i960-ucr
Name: binutils-ucr
# The version tracks the GNU version that the package is based on,
# and the release tracks the patch releases.
Version: 2.8.1
#
# Release 2 adds some missing files is /usr/local/targetdir/*
Release: 2

Copyright: GPL
Group: Development/Languages
Vendor: Picture Elements, Inc.
Packager: Stephen Williams <steve@picturel.com>
Source: ftp://prep.ai.mit.edu/pub/gnu/binutils-2.8.1.tar.gz
Patch0: binutils-2.8.1-ucr.patch

%description
Assembler, linker and related tools for targets supported by uCR.
This is the FSF source, modified to configure correctly for ucr.

%package -n binutils-i960-ucr
Summary: binutils for i960-ucr
Group: Development/Languages
%description -n binutils-i960-ucr
This is the binutils, configured and compiled for the i960-ucr target.

%package -n binutils-arm-ucr
Summary: binutils for arm-ucr
Group: Development/Languages
%description -n binutils-arm-ucr
This is the binutils, configured and compiled for the arm-ucr target.

%package -n binutils-m68k-ucr
Summary: binutils for m68k-ucr
Group: Development/Languages
%description -n binutils-m68k-ucr
This is the binutils, configured and compiled for the m68k-ucr target.

%package -n binutils-info-ucr
Summary: binutils info files
Group: Development/Languages
%description -n binutils-info-ucr
This is the binutils info files, which are common to all the targets.

%prep
%setup -c -n binutils-ucr
cd binutils-$RPM_PACKAGE_VERSION
%patch0 -p2

%build

mkdir i960-ucr
cd i960-ucr
$RPM_BUILD_DIR/binutils-ucr/binutils-$RPM_PACKAGE_VERSION/configure --target=i960-ucr --prefix=/usr/local
make CFLAGS=-O2 LDFLAGS=-s
cd ..

mkdir arm-ucr
cd arm-ucr
$RPM_BUILD_DIR/binutils-ucr/binutils-$RPM_PACKAGE_VERSION/configure --target=arm-ucr --prefix=/usr/local
make CFLAGS=-O2 LDFLAGS=-s
cd ..

mkdir m68k-ucr
cd m68k-ucr
$RPM_BUILD_DIR/binutils-ucr/binutils-$RPM_PACKAGE_VERSION/configure --target=m68k-ucr --prefix=/usr/local
make CFLAGS=-O2 LDFLAGS=-s
cd ..

%install
(cd i960-ucr ; make install)
(cd arm-ucr ; make install)
(cd m68k-ucr ; make install)

%clean
rm -rf binutils-ucr

%files -n binutils-i960-ucr

%docdir /usr/local/man
%docdir /usr/local/info

/usr/local/i960-ucr/bin/ar
/usr/local/i960-ucr/bin/as
/usr/local/i960-ucr/bin/ld
/usr/local/i960-ucr/bin/nm
/usr/local/i960-ucr/bin/ranlib
/usr/local/i960-ucr/bin/strip
/usr/local/i960-ucr/lib/ldscripts/gld960coff.x
/usr/local/i960-ucr/lib/ldscripts/gld960coff.xbn
/usr/local/i960-ucr/lib/ldscripts/gld960coff.xn
/usr/local/i960-ucr/lib/ldscripts/gld960coff.xr
/usr/local/i960-ucr/lib/ldscripts/gld960coff.xu
/usr/local/bin/i960-ucr-addr2line
/usr/local/bin/i960-ucr-ar
/usr/local/bin/i960-ucr-as
/usr/local/bin/i960-ucr-c++filt
/usr/local/bin/i960-ucr-gasp
/usr/local/bin/i960-ucr-ld
/usr/local/bin/i960-ucr-nm
/usr/local/bin/i960-ucr-objcopy
/usr/local/bin/i960-ucr-objdump
/usr/local/bin/i960-ucr-ranlib
/usr/local/bin/i960-ucr-size
/usr/local/bin/i960-ucr-strings
/usr/local/bin/i960-ucr-strip
/usr/local/man/man1/i960-ucr-addr2line.1
/usr/local/man/man1/i960-ucr-ar.1
/usr/local/man/man1/i960-ucr-as.1
/usr/local/man/man1/i960-ucr-c++filt.1
/usr/local/man/man1/i960-ucr-ld.1
/usr/local/man/man1/i960-ucr-nm.1
/usr/local/man/man1/i960-ucr-objcopy.1
/usr/local/man/man1/i960-ucr-objdump.1
/usr/local/man/man1/i960-ucr-ranlib.1
/usr/local/man/man1/i960-ucr-size.1
/usr/local/man/man1/i960-ucr-strings.1
/usr/local/man/man1/i960-ucr-strip.1


%files -n binutils-arm-ucr

%docdir /usr/local/man
%docdir /usr/local/info

/usr/local/arm-ucr/bin/ar
/usr/local/arm-ucr/bin/as
/usr/local/arm-ucr/bin/ld
/usr/local/arm-ucr/bin/nm
/usr/local/arm-ucr/bin/ranlib
/usr/local/arm-ucr/bin/strip
/usr/local/arm-ucr/lib/ldscripts/armcoff.x
/usr/local/arm-ucr/lib/ldscripts/armcoff.xbn
/usr/local/arm-ucr/lib/ldscripts/armcoff.xn
/usr/local/arm-ucr/lib/ldscripts/armcoff.xr
/usr/local/arm-ucr/lib/ldscripts/armcoff.xu
/usr/local/bin/arm-ucr-addr2line
/usr/local/bin/arm-ucr-ar
/usr/local/bin/arm-ucr-as
/usr/local/bin/arm-ucr-c++filt
/usr/local/bin/arm-ucr-gasp
/usr/local/bin/arm-ucr-ld
/usr/local/bin/arm-ucr-nm
/usr/local/bin/arm-ucr-objcopy
/usr/local/bin/arm-ucr-objdump
/usr/local/bin/arm-ucr-ranlib
/usr/local/bin/arm-ucr-size
/usr/local/bin/arm-ucr-strings
/usr/local/bin/arm-ucr-strip
/usr/local/man/man1/arm-ucr-addr2line.1
/usr/local/man/man1/arm-ucr-ar.1
/usr/local/man/man1/arm-ucr-as.1
/usr/local/man/man1/arm-ucr-c++filt.1
/usr/local/man/man1/arm-ucr-ld.1
/usr/local/man/man1/arm-ucr-nm.1
/usr/local/man/man1/arm-ucr-objcopy.1
/usr/local/man/man1/arm-ucr-objdump.1
/usr/local/man/man1/arm-ucr-ranlib.1
/usr/local/man/man1/arm-ucr-size.1
/usr/local/man/man1/arm-ucr-strings.1
/usr/local/man/man1/arm-ucr-strip.1


%files -n binutils-m68k-ucr

%docdir /usr/local/man
%docdir /usr/local/info

/usr/local/m68k-ucr/bin/ar
/usr/local/m68k-ucr/bin/as
/usr/local/m68k-ucr/bin/ld
/usr/local/m68k-ucr/bin/nm
/usr/local/m68k-ucr/bin/ranlib
/usr/local/m68k-ucr/bin/strip
/usr/local/m68k-ucr/lib/ldscripts/m68kcoff.x
/usr/local/m68k-ucr/lib/ldscripts/m68kcoff.xbn
/usr/local/m68k-ucr/lib/ldscripts/m68kcoff.xn
/usr/local/m68k-ucr/lib/ldscripts/m68kcoff.xr
/usr/local/m68k-ucr/lib/ldscripts/m68kcoff.xu
/usr/local/bin/m68k-ucr-addr2line
/usr/local/bin/m68k-ucr-ar
/usr/local/bin/m68k-ucr-as
/usr/local/bin/m68k-ucr-c++filt
/usr/local/bin/m68k-ucr-gasp
/usr/local/bin/m68k-ucr-ld
/usr/local/bin/m68k-ucr-nm
/usr/local/bin/m68k-ucr-objcopy
/usr/local/bin/m68k-ucr-objdump
/usr/local/bin/m68k-ucr-ranlib
/usr/local/bin/m68k-ucr-size
/usr/local/bin/m68k-ucr-strings
/usr/local/bin/m68k-ucr-strip
/usr/local/man/man1/m68k-ucr-addr2line.1
/usr/local/man/man1/m68k-ucr-ar.1
/usr/local/man/man1/m68k-ucr-as.1
/usr/local/man/man1/m68k-ucr-c++filt.1
/usr/local/man/man1/m68k-ucr-ld.1
/usr/local/man/man1/m68k-ucr-nm.1
/usr/local/man/man1/m68k-ucr-objcopy.1
/usr/local/man/man1/m68k-ucr-objdump.1
/usr/local/man/man1/m68k-ucr-ranlib.1
/usr/local/man/man1/m68k-ucr-size.1
/usr/local/man/man1/m68k-ucr-strings.1
/usr/local/man/man1/m68k-ucr-strip.1

%files -n binutils-info-ucr

/usr/local/info/as.info*
/usr/local/info/binutils.info*
/usr/local/info/gasp.info*
/usr/local/info/ld.info*
