#!/bin/sh

#
# Copyright (c) 1995 Picture Elements Inc.
#	Stephen Williams
#
#    This source code is free software; you can redistribute it
#    and/or modify it in source code form under the terms of the GNU
#    General Public License as published by the Free Software
#    Foundation; either version 2 of the License, or (at your option)
#    any later version. In order to redistribute the software in
#    binary form, you will need a Picture Elements Binary Software
#    License.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
#
#    You should also have recieved a copy of the Picture Elements
#    Binary Software License offer along with the source. This offer
#    allows you to obtain the right to redistribute the software in
#    binary (compiled) form. If you have not received it, contact
#    Picture Elements, Inc., 777 Panoramic Way, Berkeley, CA 94704.
#
#ident "$Id: findlibs.sh,v 1.3 1996/10/28 03:45:29 steve Exp $"
#
# This command takes -L options, like ld, then locates the -lfoo files
# or *.ld files and prints the complete path where it was found. This
# is useful for finding dependencies.
#
# $Log: findlibs.sh,v $
# Revision 1.3  1996/10/28 03:45:29  steve
#  License notice.
#
# Revision 1.2  1996/05/29 04:30:46  steve
#  Support standard linker configurations.
#
# Revision 1.1  1995/09/07 18:11:15  steve
#  Add more generalized makefiles that properly
#  handle libraries all over the place.
#


dlibdirs='/usr/lib'
ulibdirs=
rc=0
while [ $# -gt 0 ]
do
	case $1
	in

	-L*)	path=`echo $1 | sed -e 's;^-L;;'`
		ulibdirs="$ulibdirs $path"
		;;

	-l*)	name=lib`echo $1 | sed -e 's;^-l;;'`.a
		for path
		in $ulibdirs $dlibdirs
		do
		    if [ -f $path/$name ]; then
			echo $path/$name
			break
		    fi
		done
		;;

	*.ld)	name=$1
		for path
		in $ulibdirs $dlibdirs
		do
		    if [ -f $path/$name ]; then
			echo $path/$name
			break
		    fi
		done
		;;

	*)	echo 'huh?' $1 >&2
		;;

	esac

	shift
done


exit $rc
