
#
# Copyright (c) 1995 Picture Elements Inc.
#	Stephen Williams
#
#    This source code is free software; you can redistribute it
#    and/or modify it in source code form under the terms of the GNU
#    Library General Public License as published by the Free Software
#    Foundation; either version 2 of the License, or (at your option)
#    any later version. In order to redistribute the software in
#    binary form, you will need a Picture Elements Binary Software
#    License.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Library General Public License for more details.
#
#    You should have received a copy of the GNU Library General Public
#    License along with this program; if not, write to the Free
#    Software Foundation, Inc.,
#    59 Temple Place - Suite 330
#    Boston, MA 02111-1307, USA
#
#    You should also have recieved a copy of the Picture Elements
#    Binary Software License offer along with the source. This offer
#    allows you to obtain the right to redistribute the software in
#    binary (compiled) form. If you have not received it, contact
#    Picture Elements, Inc.,
#    777 Panoramic Way
#    Berkeley, CA 94704.
#
#ident "$Id: image.mk,v 1.10 1997/09/02 19:33:58 steve Exp $"
#
# $Log: image.mk,v $
# Revision 1.10  1997/09/02 19:33:58  steve
#  Change build to use i960-ucr compilers.
#
# Revision 1.9  1996/11/08 21:40:27  steve
#  Divide up thread_create for easier porting, Add the
#  sparc_linux and i386_linux targets, and adjust makefiles
#  to allow for them. Document the new concept of virtual boards.
#
#  Change the linker output file extension to .exe, because
#  some targets use ELF and not COFF.
#
#  Get rid of some trivial warnings.
#
# Revision 1.8  1996/10/28 03:45:31  steve
#  License notice.
#
# Revision 1.7  1996/10/08 17:27:28  steve
#  target suffix more PC friendly.
#
# Revision 1.6  1996/10/08 05:22:24  steve
#  Support different target types
#
# Revision 1.5  1996/09/19 04:43:58  steve
#  Add the i960_ise target, change the target
#  configuration headers to allow sharing by
#  targets, fix up the make clean rule.
#
# Revision 1.4  1996/05/29 04:30:46  steve
#  Support standard linker configurations.
#
# Revision 1.3  1996/05/27 22:41:12  steve
#  libgcc and -lucr are hopelessly intertwined.
#
# Revision 1.2  1996/05/24 01:46:37  steve
#  Initial port to i960_cyclone
#  Seperate some files in the library to seperate files
#  for making smaller binaries, use uCR_ prefix for private
#  symbols, move assembly files around for compile-time
#  portability, change __start to ucr_start and give it
#  new behavior, and simplify the ucr_assert implementation.
#
# Revision 1.1  1995/09/07 18:11:16  steve
#  Add more generalized makefiles that properly
#  handle libraries all over the place.
#

#
# This assumes that $(UCR)/make/rules.mk has been included, and the
# following macros filled in:
#
#	TARG	-- This is the target binary. Should be foo.suff.
#
#	OBJ	-- This is a list of object files. This makefile will
#		   automatically prepend any subdirs, etc.
#
#	LIBS	-- Libraries in the form -lfoo. Do not include -lucr,
#		   as it will automatically be included.
#
#	MODEL	-- This is the memory model to use. The linker uses these
#		   names to select .ld files to use.
#
# The supported suffixes are:
#
#	.sre	-- to generate S-Record format output,
#
#	.scof	-- to generate a stripped COFF file

all: $(TARG)

OBJ- := $(patsubst %, $(OBJD)/%, $(OBJ))
#LIBGCC := $(shell $(CC) $(CFLAGS) -print-libgcc-file-name)

TARG- := $(basename $(TARG))

$(TARG-).exe: $(OBJ-) $(shell $(UCR)/make/findlibs.sh $(LIBR) $(LIBS) $(MODEL) -lucr)
	$(CXX) $(LDFLAGS) $(LIBR) $(addprefix -T ,$(MODEL)) -o $(TARG-).exe $(OBJ-) $(LIBS)

#	$(LD) -M $(LDFLAGS) $(LIBR) $(addprefix -T ,$(MODEL)) -o $(TARG-).exe  $(OBJ-) $(LIBS) -\( -lucr $(LIBGCC) -\) > $(TARG-).map

%.scof: %.exe $(COFF2SCOF)
	@$(COFF2SCOF) $< $@

%.sre: %.exe $(COFF2SREC)
	@$(COFF2SREC) $< $@

clean::
	rm -f $(OBJ-) $(TARG-)
	rm -f $(patsubst %.o, %.d, $(OBJ-))

ifndef NODEP
-include $(patsubst %.o, %.d, $(OBJ-))
endif
