#! /bin/sh
#
# Copyright (c) 1997 Picture Elements, Inc.
#	Stephen Williams (steve@picturel.com)
#
#    This source code is free software; you can redistribute it
#    and/or modify it in source code form under the terms of the GNU
#    General Public License as published by the Free Software
#    Foundation; either version 2 of the License, or (at your option)
#    any later version. In order to redistribute the software in
#    binary form, you will need a Picture Elements Binary Software
#    License.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
#
#    You should also have recieved a copy of the Picture Elements
#    Binary Software License offer along with the source. This offer
#    allows you to obtain the right to redistribute the software in
#    binary (compiled) form. If you have not received it, contact
#    Picture Elements, Inc., 777 Panoramic Way, Berkeley, CA 94704.
#
# $Id: img2obj.sh,v 1.2 1997/12/31 01:24:51 steve Exp $
#
# $Log: img2obj.sh,v $
# Revision 1.2  1997/12/31 01:24:51  steve
#  Remove references to i960-coff tools.
#
# Revision 1.1  1997/02/05 05:25:03  steve
#  Add support for xact images.
#

# This script takes a raw file and puts it into a linkable COFF file.
# The image of the original file is surrounded by the symbols foo_begin
# and foo_end, where foo is the basename (without the .img suffix) of the
# image.

name=`basename $1 .img`
obj=$2

tmp=/tmp/img2obj$$

# Set u to _ if the generated symbol name should have a _ in front.
u=_

# This is the section where the image is to go. The .text section is
# a good choice because that is usually placed in ROM.
sect=.text


echo | i960-ucr-as -o ${tmp}.o --
i960-ucr-objcopy --add-section .tmp=$1 ${tmp}.o

cat > ${tmp}.ld <<EOF
SECTIONS {
${sect} : { $u${name}_start = . ; ${tmp}.o(.tmp) ; $u${name}_end = .; }
}
EOF

i960-ucr-ld -r -x --script=${tmp}.ld -o $obj ${tmp}.o

rm -f ${tmp}.ld ${tmp}.o
