/*
 * Copyright (c) 1997 Picture Elements, Inc.
 *    Stephen Williams (steve@picturel.com)
 *
 *    This source code is free software; you can redistribute it
 *    and/or modify it in source code form under the terms of the GNU
 *    Library General Public License as published by the Free Software
 *    Foundation; either version 2 of the License, or (at your option)
 *    any later version. In order to redistribute the software in
 *    binary form, you will need a Picture Elements Binary Software
 *    License.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU Library General Public License for more details.
 *
 *    You should have received a copy of the GNU Library General Public
 *    License along with this program; if not, write to the Free
 *    Software Foundation, Inc.,
 *    59 Temple Place - Suite 330
 *    Boston, MA 02111-1307, USA
 *
 *    You should also have recieved a copy of the Picture Elements
 *    Binary Software License offer along with the source. This offer
 *    allows you to obtain the right to redistribute the software in
 *    binary (compiled) form. If you have not received it, contact
 *    Picture Elements, Inc.,
 *    777 Panoramic Way
 *    Berkeley, CA 94704.
 */
#ident "$Id: BIOS32_a.cc,v 1.2 1997/03/28 03:23:10 steve Exp $"
/*
 * $Log: BIOS32_a.cc,v $
 * Revision 1.2  1997/03/28 03:23:10  steve
 *  config space IO checks for errors.
 *
 * Revision 1.1  1997/03/27 00:08:55  steve
 *  Add the PLX9060 PCI side driver, and make
 *  the BIOS32 support short word config cycles.
 *
 */

/* SEE BIOS32.cc FOR DETAILS */

# include  <chips/BIOS32.h>
# include  <assert.h>

bool BIOS32::read_config_word(unsigned char bus, unsigned char dev_fn,
			      unsigned char reg_id, unsigned short&out) const
{
      unsigned long tmp;
      if (! read_config_dword(bus, dev_fn, reg_id&~3, tmp)) return false;

      if (reg_id&2) out = tmp >> 16;
      else out = tmp & 0xffff;

      return true;
}

bool BIOS32::write_config_word(unsigned char bus,
			       unsigned char dev_fn,
			       unsigned char reg_id,
			       unsigned short value) const
{
      unsigned long tmp;
      if (! read_config_dword(bus, dev_fn, reg_id&~3, tmp)) return false;

      if (reg_id&2) tmp = (tmp&0xffff) | ((unsigned long)value<<16);
      else tmp = (tmp&0xffff0000) | value;

      return write_config_dword(bus, dev_fn, reg_id&~3, tmp);
}
