/*
 * Copyright (c) 1996 Picture Elements, Inc.
 *    Stephen Williams
 */
#ident "$Id: LinuxIO.cc,v 1.1 1996/11/10 19:29:04 steve Exp $"
/*
 * $Log: LinuxIO.cc,v $
 * Revision 1.1  1996/11/10 19:29:04  steve
 *  Add setjmp and longjmp for the i386,
 *  Add support for linux system calls on i386,
 *  and add a LinuxIO device driver.
 *
 */

# include  <chips/LinuxIO.h>
# include  <ucr/ucr.h>
# include  <string.h>
# include  <assert.h>

class LinuxDevice  : public StdioDevice {

    public:
      LinuxDevice(int fd) : fd_(fd) { }
      ~LinuxDevice();

      void write(const void*str, size_t cnt);
      int  read(void*str, size_t cnt);

    private:
      const int fd_;
};

LinuxIO::LinuxIO()
: StdioDeviceType("linux")
{
}

LinuxIO::~LinuxIO()
{
}

StdioDevice* LinuxIO::open(const char*name)
{
      if (strcmp(name, "stdin")  == 0) return new LinuxDevice(0);
      if (strcmp(name, "stdout") == 0) return new LinuxDevice(1);
      if (strcmp(name, "stderr") == 0) return new LinuxDevice(2);
      return 0;
}

void LinuxIO::close(StdioDevice*dev)
{
      delete dev;
}

LinuxDevice::~LinuxDevice()
{
}

void LinuxDevice::write(const void*str, size_t cnt)
{
      call_host3(__SYSCALL_write, fd_, (int)str, (int)cnt);
}

int LinuxDevice::read(void*str, size_t cnt)
{
      int rc = call_host3(__SYSCALL_read, fd_, (int)str, (int)cnt);
      return rc;
}
