/*
 * Copyright (c) 1996 Picture Elements, Inc.
 *    Stephen Williams
 *
 *    This source code is free software; you can redistribute it
 *    and/or modify it in source code form under the terms of the GNU
 *    Library General Public License as published by the Free Software
 *    Foundation; either version 2 of the License, or (at your option)
 *    any later version. In order to redistribute the software in
 *    binary form, you will need a Picture Elements Binary Software
 *    License.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU Library General Public License for more details.
 *
 *    You should have received a copy of the GNU Library General Public
 *    License along with this program; if not, write to the Free
 *    Software Foundation, Inc.,
 *    59 Temple Place - Suite 330
 *    Boston, MA 02111-1307, USA
 *
 *    You should also have recieved a copy of the Picture Elements
 *    Binary Software License offer along with the source. This offer
 *    allows you to obtain the right to redistribute the software in
 *    binary (compiled) form. If you have not received it, contact
 *    Picture Elements, Inc.,
 *    777 Panoramic Way
 *    Berkeley, CA 94704.
 */
#ident "$Id: gdb_thread.cc,v 1.3 1996/10/31 00:40:45 steve Exp $"
/*
 * $Log: gdb_thread.cc,v $
 * Revision 1.3  1996/10/31 00:40:45  steve
 *  Add pause for explicit breakpoints.
 *
 * Revision 1.2  1996/10/28 03:45:45  steve
 *  License notice.
 *
 * Revision 1.1  1996/10/22 03:58:58  steve
 *  Create a debug.h header for debugger tools other then
 *  the GDB class itself, and create a gdb_thread function
 *  to start a GDB thread.
 *
 */

# include  <gdb/GDB.h>
# include  <gdb/debug.h>
# include  <chips/BUS.h>
# include  <ucr/ucr.h>


BUS::Channel debug_port (255);
GDB gdb (&debug_port);

static unsigned long gdb_thread_stack[512];
static void gdb_thread_p(void*)
{
      gdb.go();
}

void gdb_thread(BUS*bus)
{
      bus->open_channel(&debug_port);

      THREAD *tid = thread_create(gdb_thread_stack,
				  sizeof gdb_thread_stack,
				  gdb_thread_p, 0);
      thread_runnable(tid);
}

void gdb_pause()
{
      gdb.pause();
}
