#ifndef __ieeefp_H
#define __ieeefp_H
/*
 * Copyright (c) 1996 Picture Elements, Inc.
 *    Stephen Williams (steve@picturel.com)
 *
 *    This source code is free software; you can redistribute it
 *    and/or modify it in source code form under the terms of the GNU
 *    Library General Public License as published by the Free Software
 *    Foundation; either version 2 of the License, or (at your option)
 *    any later version. In order to redistribute the software in
 *    binary form, you will need a Picture Elements Binary Software
 *    License.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU Library General Public License for more details.
 *
 *    You should have received a copy of the GNU Library General Public
 *    License along with this program; if not, write to the Free
 *    Software Foundation, Inc.,
 *    59 Temple Place - Suite 330
 *    Boston, MA 02111-1307, USA
 *
 *    You should also have recieved a copy of the Picture Elements
 *    Binary Software License offer along with the source. This offer
 *    allows you to obtain the right to redistribute the software in
 *    binary (compiled) form. If you have not received it, contact
 *    Picture Elements, Inc.,
 *    777 Panoramic Way
 *    Berkeley, CA 94704.
 */
#ident "$Id: ieeefp.h,v 1.5 1997/02/21 21:43:22 steve Exp $"
/*
 * $Log: ieeefp.h,v $
 * Revision 1.5  1997/02/21 21:43:22  steve
 *  Update m68k support for newer config structure.
 *
 * Revision 1.4  1996/11/15 16:54:21  steve
 *  Include i386 in word order selection.
 *
 * Revision 1.3  1996/11/12 00:38:49  steve
 *  Implement the sparc longjmp, fix the IEEEFP byte
 *  extraction for sparc, add the UCR_STACK_ATTRIBUTE
 *  definition and get the regress test to work for sparc_linux.
 *
 * Revision 1.2  1996/10/28 03:45:47  steve
 *  License notice.
 *
 * Revision 1.1  1996/10/23 20:14:40  steve
 *  Fix bogus IEEE bit munging.
 *
 */


union ieee_double_shape {
      double val;
      unsigned long bits[2];
};

/*
 * These macros take 64bit floating point numbers and break them into
 * 2 32bit integers.
 */

#if defined(i960_cyclone) || defined(i960_ise) || defined(i386_linux)
# define __ILOW_WORD 0
# define __IHIGH_WORD 1
#elif defined(sparc_linux) || defined(m68k_coff)
# define __ILOW_WORD 1
# define __IHIGH_WORD 0
#endif

#define SPLIT_DOUBLE(d, high, low) do { \
			      union ieee_double_shape ss; \
			      ss.val = d; \
			      low = ss.bits[__ILOW_WORD]; \
			      high = ss.bits[__IHIGH_WORD]; } while(0)

# define JOIN_DOUBLE(d, high, low) do { \
			      union ieee_double_shape ss; \
			      ss.bits[__ILOW_WORD] = low; \
			      ss.bits[__IHIGH_WORD] = high; \
			      d = ss.val; } while(0)


#endif
