#ifndef __ParallelPort_priv_H
#define __ParallelPort_priv_H
/*
 * Copyright (c) 1995 Picture Elements Inc.
 *	Stephen Williams
 *
 *    This source code is free software; you can redistribute it
 *    and/or modify it in source code form under the terms of the GNU
 *    Library General Public License as published by the Free Software
 *    Foundation; either version 2 of the License, or (at your option)
 *    any later version. In order to redistribute the software in
 *    binary form, you will need a Picture Elements Binary Software
 *    License.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU Library General Public License for more details.
 *
 *    You should have received a copy of the GNU Library General Public
 *    License along with this program; if not, write to the Free
 *    Software Foundation, Inc.,
 *    59 Temple Place - Suite 330
 *    Boston, MA 02111-1307, USA
 *
 *    You should also have recieved a copy of the Picture Elements
 *    Binary Software License offer along with the source. This offer
 *    allows you to obtain the right to redistribute the software in
 *    binary (compiled) form. If you have not received it, contact
 *    Picture Elements, Inc.,
 *    777 Panoramic Way
 *    Berkeley, CA 94704.
 */
#ident "$Id: ParallelPort_priv.h,v 1.2 1996/10/28 03:45:55 steve Exp $"
/*
 * $Log: ParallelPort_priv.h,v $
 * Revision 1.2  1996/10/28 03:45:55  steve
 *  License notice.
 *
 * Revision 1.1  1995/11/02 06:57:22  steve
 *  Split up the ParallelPort source,
 *  Support nibble mode id strings.
 *
 */


  // These are values for the various fields of the PPCR
  // register. (See the mc68322 User's Manual, section 9.1.2.) This
  // register controls the hardware handshaking of the port.
const unsigned short PPCR_COMPAT_MODE = 0x0004;
const unsigned short PPCR_ECP_MODE    = 0x0008;
const unsigned short PPCR_ECPRLE_MODE = 0x000c;

const unsigned short PPCR_FILTER     = 0x0002;
const unsigned short PPCR_OUT_ENABLE = 0x0020;

  // NOTE: Line filtering is a necessity, especially with PDMA active,
  // because PCs make yucky noisy nStrobe signals. This causes bytes
  // to be latched multiple times, and generally makes a mess.

  // Interrupt bits for PPI control. HIGH_ events are rising edges,
  // and LOW_ events are falling edges. All of these events are
  // interrupt events.
const unsigned short HIGH_nSelectIn = 0x0001;
const unsigned short LOW_nSelectIn  = 0x0002;
const unsigned short HIGH_nStrobe   = 0x0004;
const unsigned short LOW_nStrobe    = 0x0008;
const unsigned short HIGH_nAutoFd   = 0x0010;
const unsigned short LOW_nAutoFd    = 0x0020;
const unsigned short HIGH_nInit     = 0x0040;
const unsigned short LOW_nInit      = 0x0080;

const unsigned short DATA_RECEIVED  = 0x0100;
const unsigned short CMD_RECEIVED   = 0x0200;


  // Interrupt bits for PDMA.
const unsigned short TERMINAL_COUNT = 0x0004;
const unsigned short DMA_COMPLETE   = 0x0002;
const unsigned short ILLEGAL_ADDRESS= 0x0001;

const unsigned short PDMA_MAX_COUNT = 0x3fff;

  // These are the lines that I can control or read. They are found in
  // the "lines" register (PPIR).

  // NOTE: nAck2 needs to be SET to force nAck LOW. This is ugly, but
  // it is how the 68322 works.
const unsigned short PIN_nFault    = 0x0001;
const unsigned short PIN_Select    = 0x0002;
const unsigned short PIN_PError    = 0x0004;
const unsigned short PIN_Busy2     = 0x0008;
const unsigned short PIN_nAck2     = 0x0010;
const unsigned short PIN_nSelectIn = 0x0080;
const unsigned short PIN_nStrobe   = 0x0100;
const unsigned short PIN_nAutoFd   = 0x0200;
const unsigned short PIN_nInit     = 0x0400;

#endif
