/*
 * Copyright (c) 1996 Picture Elements, Inc.
 *    Stephen Williams
 *
 *    This source code is free software; you can redistribute it
 *    and/or modify it in source code form under the terms of the GNU
 *    Library General Public License as published by the Free Software
 *    Foundation; either version 2 of the License, or (at your option)
 *    any later version. In order to redistribute the software in
 *    binary form, you will need a Picture Elements Binary Software
 *    License.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU Library General Public License for more details.
 *
 *    You should have received a copy of the GNU Library General Public
 *    License along with this program; if not, write to the Free
 *    Software Foundation, Inc.,
 *    59 Temple Place - Suite 330
 *    Boston, MA 02111-1307, USA
 *
 *    You should also have recieved a copy of the Picture Elements
 *    Binary Software License offer along with the source. This offer
 *    allows you to obtain the right to redistribute the software in
 *    binary (compiled) form. If you have not received it, contact
 *    Picture Elements, Inc.,
 *    777 Panoramic Way
 *    Berkeley, CA 94704.
 */
#ident "$Id: fgetc.cc,v 1.2 1996/10/28 03:46:01 steve Exp $"
/*
 * $Log: fgetc.cc,v $
 * Revision 1.2  1996/10/28 03:46:01  steve
 *  License notice.
 *
 * Revision 1.1  1996/09/19 01:38:32  steve
 *  Add fgetc and fgets. stdio input works.
 *
 */

# include  "stdiox.h"

extern "C" int fgetc(FILE*stream)
{
      if (! (stream->flags&_FILE::F_READ)) return EOF;

      switch (stream->state) {

	  case _FILE::S_ERROR:
	  case _FILE::S_WRITE:
	    return EOF;

	  case _FILE::S_IDLE:
	    stream->state = _FILE::S_READ;
	    stream->buf_ptr = stream->buf;
	    stream->buf_end = stream->buf;
	  case _FILE::S_READ:
	    break;
      }

	// XXXX For now, ignore buffering options and read single
	// characters from the device.

      char buf[1];
      int rc;

      switch (stream->buf_mode) {
	  case _IONBF:
	    rc = stream->dev->read(buf, 1);
	    if (rc <= 0) {
		  stream->state = _FILE::S_ERROR;
		  return EOF;
	    }
	    break;

	  case _IOLBF:
	  case _IOFBF:
	    if (stream->buf_ptr == stream->buf_end) {
		  rc = stream->dev->read(stream->buf, stream->buf_len);
		  if (rc <= 0) return EOF;
		  stream->buf_end = stream->buf + rc;
		  stream->buf_ptr = stream->buf;
	    }

	    buf[0] = *stream->buf_ptr++;
	    break;
      }

      return (int)(unsigned)buf[0];
}
