/*
 * Copyright (c) 1996 Picture Elements, Inc.
 *    Stephen Williams
 *
 *    This source code is free software; you can redistribute it
 *    and/or modify it in source code form under the terms of the GNU
 *    Library General Public License as published by the Free Software
 *    Foundation; either version 2 of the License, or (at your option)
 *    any later version. In order to redistribute the software in
 *    binary form, you will need a Picture Elements Binary Software
 *    License.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU Library General Public License for more details.
 *
 *    You should have received a copy of the GNU Library General Public
 *    License along with this program; if not, write to the Free
 *    Software Foundation, Inc.,
 *    59 Temple Place - Suite 330
 *    Boston, MA 02111-1307, USA
 *
 *    You should also have recieved a copy of the Picture Elements
 *    Binary Software License offer along with the source. This offer
 *    allows you to obtain the right to redistribute the software in
 *    binary (compiled) form. If you have not received it, contact
 *    Picture Elements, Inc.,
 *    777 Panoramic Way
 *    Berkeley, CA 94704.
 */
#ident "$Id: fread.cc,v 1.1 1996/10/29 01:58:51 steve Exp $"
/*
 * $Log: fread.cc,v $
 * Revision 1.1  1996/10/29 01:58:51  steve
 *  Add fread to libstdio.
 *
 */

# include  <stdio.h>
# include  "stdiox.h"
# include  <assert.h>

extern "C" size_t fread(void*ptr, size_t size, size_t nmemb, FILE*stream)
{
      assert( stream->flags & _FILE::F_READ );
      assert( stream->state != _FILE::S_WRITE );

      if (stream->state == _FILE::S_ERROR) return 0;
      stream->state = _FILE::S_READ;

      size_t len = size*nmemb;

      switch (stream->buf_mode) {

	  case _IONBF:
	    stream->dev->read(ptr, len);
	    break;

	  case _IOLBF: // Whoops, buffered input not yet supported
	  case _IOFBF:
	    stream->dev->read(ptr, len);
	    break;

      }

      return nmemb;
}

