/*
 * Copyright (c) 1996 Picture Elements, Inc.
 *    Stephen Williams (steve@icarus.com)
 *
 *    This source code is free software; you can redistribute it
 *    and/or modify it in source code form under the terms of the GNU
 *    Library General Public License as published by the Free Software
 *    Foundation; either version 2 of the License, or (at your option)
 *    any later version. In order to redistribute the software in
 *    binary form, you will need a Picture Elements Binary Software
 *    License.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU Library General Public License for more details.
 *
 *    You should have received a copy of the GNU Library General Public
 *    License along with this program; if not, write to the Free
 *    Software Foundation, Inc.,
 *    59 Temple Place - Suite 330
 *    Boston, MA 02111-1307, USA
 *
 *    You should also have recieved a copy of the Picture Elements
 *    Binary Software License offer along with the source. This offer
 *    allows you to obtain the right to redistribute the software in
 *    binary (compiled) form. If you have not received it, contact
 *    Picture Elements, Inc.,
 *    777 Panoramic Way
 *    Berkeley, CA 94704.
 */
#ident "$Id: setbuf.cc,v 1.1 1996/10/29 23:41:43 steve Exp $"
/*
 * $Log: setbuf.cc,v $
 * Revision 1.1  1996/10/29 23:41:43  steve
 *  Add an implementation of calloc. This just calls
 *  malloc and clears the buffer.
 *
 *  Add implementatsion of printf and setbuf. Note
 *  that printf uses standard streams. I make the standard
 *  streams extern so that the compiler finds them. This
 *  allows targets that have the means to support those streams.
 *
 *  Add the exit() function, which is C and C++ standard.
 *  The _exit() function, which is POSIX, is still needed
 *  for the benifit of libgcc.
 *
 */

# include  <stdio.h>

extern "C" void setbuf(FILE*stream, char*buf)
{ setvbuf(stream, buf, buf? _IOFBF : _IONBF, BUFSIZ); }
