/*
 * Copyright (c) 1998 Picture Elements, Inc.
 *    Stephen Williams (steve@picturel.com)
 *
 *    This source code is free software; you can redistribute it
 *    and/or modify it in source code form under the terms of the GNU
 *    General Public License as published by the Free Software
 *    Foundation; either version 2 of the License, or (at your option)
 *    any later version. In order to redistribute the software in
 *    binary form, you will need a Picture Elements Binary Software
 *    License.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 *  ---
 *    You should also have recieved a copy of the Picture Elements
 *    Binary Software License offer along with the source. This offer
 *    allows you to obtain the right to redistribute the software in
 *    binary (compiled) form. If you have not received it, contact
 *    Picture Elements, Inc., 777 Panoramic Way, Berkeley, CA 94704.
 */
#if !defined(WINNT)
#ident "$Id: heap_test_ext.cc,v 1.1 1998/04/11 23:41:19 steve Exp $"
#endif

# include  <ucr/heap.h>
# include  "__heap.h"
# include  <assert.h>

/*
 * This function checks that the pointer is within the extent of the
 * allocated memory. While I'm at it, make a few checks that the cell
 * really is well-formed.
 */
extern "C" int heap_test_ext(const void*memory, const void*ptr)
{
      assert(memory);

      HeapCell*cell = ((const HeapCell*)memory) - 1;
      assert( cell->free == 0 );
      assert( cell->next > cell );
      assert( (cell->next - cell) == cell->size );

      if (ptr < (const void*) (cell+1))
	    return 1;

      if (ptr >= (const void*) (cell->next))
	    return 1;

      return 0;
}

/*
 * $Log: heap_test_ext.cc,v $
 * Revision 1.1  1998/04/11 23:41:19  steve
 *  Add cell extent tests.
 *
 */

