/*
 * Copyright (c) 1996 Picture Elements, Inc.
 *    Stephen Williams
 *
 *    This source code is free software; you can redistribute it
 *    and/or modify it in source code form under the terms of the GNU
 *    Library General Public License as published by the Free Software
 *    Foundation; either version 2 of the License, or (at your option)
 *    any later version. In order to redistribute the software in
 *    binary form, you will need a Picture Elements Binary Software
 *    License.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU Library General Public License for more details.
 *
 *    You should have received a copy of the GNU Library General Public
 *    License along with this program; if not, write to the Free
 *    Software Foundation, Inc.,
 *    59 Temple Place - Suite 330
 *    Boston, MA 02111-1307, USA
 *
 *    You should also have recieved a copy of the Picture Elements
 *    Binary Software License offer along with the source. This offer
 *    allows you to obtain the right to redistribute the software in
 *    binary (compiled) form. If you have not received it, contact
 *    Picture Elements, Inc.,
 *    777 Panoramic Way
 *    Berkeley, CA 94704.
 */
#ident "$Id: main_thread.cc,v 1.6 1996/11/12 00:38:51 steve Exp $"
/*
 * $Log: main_thread.cc,v $
 * Revision 1.6  1996/11/12 00:38:51  steve
 *  Implement the sparc longjmp, fix the IEEEFP byte
 *  extraction for sparc, add the UCR_STACK_ATTRIBUTE
 *  definition and get the regress test to work for sparc_linux.
 *
 * Revision 1.5  1996/10/28 03:46:27  steve
 *  License notice.
 *
 * Revision 1.4  1996/09/17 21:51:39  steve
 *  Add support for errno.h
 *
 * Revision 1.3  1996/08/22 00:35:43  steve
 *  main stack has beginning and end.
 *
 * Revision 1.2  1996/08/14 00:24:50  steve
 *  Add fault information to the THREAD object so that
 *  it can be retrieved at any time.
 *
 * Revision 1.1  1996/08/03 03:30:41  steve
 *  Create the ucr/asm.h header as a target specific
 *  header with line functions, etc; Replace the
 *  __isr_run_flag with a bit of inline assembly code.
 *
 *  Move much thread code out of the __Secheduler class
 *  and into more public thread_ functions, to eliminate
 *  some wasted function call depth. Even the main_thread
 *  is move into its own file.
 *
 *  Keep a list of available threads for debug use, and
 *  add a function to get thread registers.
 *
 */

# include  "__thread.h"
# include  <ucr/ucr.h>
extern "C" unsigned char bstack, estack;

/*
 * NOTE: These must have passive initializers. There are constructors
 * for static objects that uses these values.
 */

static THREAD main_thread __attribute__ ((UCR_STACK_ATTRIBUTE))
      = { COOKIE_INITIALIZER,
	  &bstack, &estack,
	  0, // errno_
	  0, // fault_
	  0, 0, // next_ and prev_
	  0, // owner_
	  &main_thread };

THREAD* uCR_current_thread = &main_thread;

