/*
 * Copyright (c) 1996 Picture Elements, Inc.
 *    Stephen Williams
 *
 *    This source code is free software; you can redistribute it
 *    and/or modify it in source code form under the terms of the GNU
 *    Library General Public License as published by the Free Software
 *    Foundation; either version 2 of the License, or (at your option)
 *    any later version. In order to redistribute the software in
 *    binary form, you will need a Picture Elements Binary Software
 *    License.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU Library General Public License for more details.
 *
 *    You should have received a copy of the GNU Library General Public
 *    License along with this program; if not, write to the Free
 *    Software Foundation, Inc.,
 *    59 Temple Place - Suite 330
 *    Boston, MA 02111-1307, USA
 *
 *    You should also have recieved a copy of the Picture Elements
 *    Binary Software License offer along with the source. This offer
 *    allows you to obtain the right to redistribute the software in
 *    binary (compiled) form. If you have not received it, contact
 *    Picture Elements, Inc.,
 *    777 Panoramic Way
 *    Berkeley, CA 94704.
 */
#ident "$Id: malloc_init.cc,v 1.2 1996/10/28 03:46:29 steve Exp $"
/*
 * $Log: malloc_init.cc,v $
 * Revision 1.2  1996/10/28 03:46:29  steve
 *  License notice.
 *
 * Revision 1.1  1996/05/24 01:46:49  steve
 *  Initial port to i960_cyclone
 *  Seperate some files in the library to seperate files
 *  for making smaller binaries, use uCR_ prefix for private
 *  symbols, move assembly files around for compile-time
 *  portability, change __start to ucr_start and give it
 *  new behavior, and simplify the ucr_assert implementation.
 *
 */


# include  <ucr/heap.h>
# include  <ucr/ucr.h>

HEAP_SPACE*uCR_malloc_heap = 0;

/*
 * The __malloc_init() call does not need to be protected from threads
 * because it is called before main, and before threads or ISRs
 * exist. This needs to be done manually in __start() because static
 * initializers might need malloc. See __start() for when it happens.
 */

extern "C" void uCR_malloc_init(void*heap, size_t heap_size)
{
      uCR_malloc_heap = heap_init(heap, heap_size);
}

