/*
 * Copyright (c) 1997 Picture Elements, Inc.
 *    Stephen Williams
 *
 *    This source code is free software; you can redistribute it
 *    and/or modify it in source code form under the terms of the GNU
 *    Library General Public License as published by the Free Software
 *    Foundation; either version 2 of the License, or (at your option)
 *    any later version. In order to redistribute the software in
 *    binary form, you will need a Picture Elements Binary Software
 *    License.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU Library General Public License for more details.
 *
 *    You should have received a copy of the GNU Library General Public
 *    License along with this program; if not, write to the Free
 *    Software Foundation, Inc.,
 *    59 Temple Place - Suite 330
 *    Boston, MA 02111-1307, USA
 *
 *    You should also have recieved a copy of the Picture Elements
 *    Binary Software License offer along with the source. This offer
 *    allows you to obtain the right to redistribute the software in
 *    binary (compiled) form. If you have not received it, contact
 *    Picture Elements, Inc.,
 *    777 Panoramic Way
 *    Berkeley, CA 94704.
 */
#ident "$Id: strtod.c,v 1.1 1997/04/25 18:46:15 steve Exp $"
/*
 * $Log: strtod.c,v $
 * Revision 1.1  1997/04/25 18:46:15  steve
 *  More ISO C support.
 *
 */

# include  <stdlib.h>
# include  <ctype.h>

/* XXXX
 * This implementation is sorely lacking a proper understanding of all
 * the details of making a double precision number. This is just a
 * cheap hack to get past an immediate hurdle, and must be rewritten
 * to be even marginally reasonable.
 */

double strtod(const char*nptr, char**endptr)
{
      const char*cp = nptr;
      int negative = 0;
      int ok_flag = 1;
      double result = 0.0;

      while (isspace(*cp)) cp += 1;

      switch (*cp) {
	  case '-':
	    negative = 1;
	  case '+':
	    cp += 1;
	  case '.':
	  case '0' ... '9':
	    break;
	  default:
	    goto error;
      }

      while (isdigit(*cp)) result = result * 10.0 + (double)(*cp - '0');

      if (*cp == '.') {
	    double tmp = 0.0;
	    int cnt = 0;
	    cp += 1;
	    while (isdigit(*cp)) {
		  tmp = tmp * 10.0 + (double)(*cp - '0');
		  cnt += 1;
	    }
	    while (cnt--) tmp /= 10.0;
	    result += tmp;
      }

	/* XXXX ERROR! I do not yet take care of the optional
	   exponent. */
done:
      if (endptr) *endptr = cp;
      return result;
error:
      if (endptr) *endptr = nptr;
      return 0.0;
}
