
!
! Copyright (c) 1996 Picture Elements Inc.
!	Stephen Williams
!
!    This source code is free software; you can redistribute it
!    and/or modify it in source code form under the terms of the GNU
!    Library General Public License as published by the Free Software
!    Foundation; either version 2 of the License, or (at your option)
!    any later version. In order to redistribute the software in
!    binary form, you will need a Picture Elements Binary Software
!    License.
!
!    This program is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU Library General Public License for more details.
!
!    You should have received a copy of the GNU Library General Public
!    License along with this program; if not, write to the Free
!    Software Foundation, Inc.,
!    59 Temple Place - Suite 330
!    Boston, MA 02111-1307, USA
!
!    You should also have recieved a copy of the Picture Elements
!    Binary Software License offer along with the source. This offer
!    allows you to obtain the right to redistribute the software in
!    binary (compiled) form. If you have not received it, contact
!    Picture Elements, Inc.,
!    777 Panoramic Way
!    Berkeley, CA 94704.
!
.ident "$Id: uCR_switch-sparc.s,v 1.1 1996/11/08 21:40:47 steve Exp $"
!
! $Log: uCR_switch-sparc.s,v $
! Revision 1.1  1996/11/08 21:40:47  steve
!  Divide up thread_create for easier porting, Add the
!  sparc_linux and i386_linux targets, and adjust makefiles
!  to allow for them. Document the new concept of virtual boards.
!
!  Change the linker output file extension to .exe, because
!  some targets use ELF and not COFF.
!
!  Get rid of some trivial warnings.
!
!
	.file	"uCR_switch-sparc.s"

! The caller registers are those that I want to switch, not mine. Therefore,
! my local and output registers are garbage.
!
! My in registers are the out registers of the caller and are interesting.
! I save the current set in the (self) cookie and restore the other set from
! the (to) cookie.

! uCR_switch(ThreadCookie*to, ThreadCookie*self)
! Calling sequence for sparc is
!   %i0  -- to
!   %i1  -- self

	.global uCR_switch
uCR_switch:
	save	%sp,-64,%sp

	mov	%i0, %o0

  ! Save the global registers and my in (the caller's out) registers
  ! in the (self) cookie. Store the %y register where %g0 would have gone.

	mov	%y, %o1
	st	%o1, [%i1]

	st	%g1, [%i1 + 4]
	std	%g2, [%i1 + 8]
	std	%g4, [%i1 + 16]
	std	%g6, [%i1 + 24]
	std	%i0, [%i1 + 32]
	std	%i2, [%i1 + 40]
	std	%i4, [%i1 + 48]
	std	%i6, [%i1 + 56]

  ! Spill the caller's in and local registers to the stack. The operating
  ! environment uses this trap as a code to do the spilling.

	ta	3

  ! Get my in (the other caller's out) registers from the (to) cookie. The
  ! %y and %g1 register are loaded together and moved into their respective
  ! places.

	ldd	[%o0 + 56], %i6
	ldd	[%o0 + 48], %i4
	ldd	[%o0 + 40], %i2
	ldd	[%o0 + 32], %i0
	ldd	[%o0 + 24], %g6
	ldd	[%o0 + 16], %g4
	ldd	[%o0 + 8] , %g2

	ldd	[%o0], %o2
	mov	%o2, %y
	mov	%o3, %g1

  ! Return into the other caller's frame. The restore moves the in registers
  ! to the caller's out registers and underflows the register window, thus
  ! causing the caller's local and in register to be restored.

	jmpl	%i7+8, %g0
	restore
