
/*
 * Copyright (c) 1995 Picture Elements Inc.
 *	Stephen Williams
 *
 *    This source code is free software; you can redistribute it
 *    and/or modify it in source code form under the terms of the GNU
 *    Library General Public License as published by the Free Software
 *    Foundation; either version 2 of the License, or (at your option)
 *    any later version. In order to redistribute the software in
 *    binary form, you will need a Picture Elements Binary Software
 *    License.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU Library General Public License for more details.
 *
 *    You should have received a copy of the GNU Library General Public
 *    License along with this program; if not, write to the Free
 *    Software Foundation, Inc.,
 *    59 Temple Place - Suite 330
 *    Boston, MA 02111-1307, USA
 *
 *    You should also have recieved a copy of the Picture Elements
 *    Binary Software License offer along with the source. This offer
 *    allows you to obtain the right to redistribute the software in
 *    binary (compiled) form. If you have not received it, contact
 *    Picture Elements, Inc.,
 *    777 Panoramic Way
 *    Berkeley, CA 94704.
 */
#ident "$Id: ucr_assert-i960_ise.cc,v 1.4 1998/05/26 16:03:36 steve Exp $"
/*
 * $Log: ucr_assert-i960_ise.cc,v $
 * Revision 1.4  1998/05/26 16:03:36  steve
 *  Add panic.
 *
 * Revision 1.3  1998/04/03 01:45:29  steve
 *  Write the trailing null.
 *
 * Revision 1.2  1998/04/03 01:35:12  steve
 *  Add assertion support.
 *
 * Revision 1.1  1997/06/15 20:07:29  steve
 *  ISE assert that leave file/line info.
 *
 */

# include  <string.h>
# include  <assert.h>

/*
 * This implementation of assert writes into the index register area
 * the information about the place of the assertion failure. The
 * index_space is set up by the locore file for proper alignment.
 */
extern unsigned char __index_space asm("__index_space__");

extern "C" void ucr_panic(const char*msg, unsigned code)
{
      unsigned long*dump_area = (unsigned long*)(&__index_space + 0x50);
      *dump_area++ = 0xab0440ba;
      *dump_area++ = code;
      *dump_area++ = strlen(msg)+1;
      strcpy((char*)dump_area, msg);
      abort();
}

/*
 * In order to get extra information to the user of an ISE board, this
 * version of the assert loads a diagnostic message into a buffer and
 * adjusts the address translation registers to give the host access.
 */
extern "C" void ucr_assert(const char* file, unsigned line)
{
      ucr_panic(file, line);
}
