#!tclpci -f

# --
# Copyright (c) 1996 Picture Elements, Inc.
# Stephen Williams (steve@icarus.com)
#
#    This source code is free software; you can redistribute it
#    and/or modify it in source code form under the terms of the GNU
#    General Public License as published by the Free Software
#    Foundation; either version 2 of the License, or (at your option)
#    any later version. In order to redistribute the software in
#    binary form, you will need a Picture Elements Binary Software
#    License.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
#
#    You should also have recieved a copy of the Picture Elements
#    Binary Software License offer along with the source. This offer
#    allows you to obtain the right to redistribute the software in
#    binary (compiled) form. If you have not received it, contact
#    Picture Elements, Inc., 777 Panoramic Way, Berkeley, CA 94704.
#
# $Id: start_ise.tcl,v 1.2 1996/10/28 03:46:52 steve Exp $
#
# $Log: start_ise.tcl,v $
# Revision 1.2  1996/10/28 03:46:52  steve
#  License notice.
#
# Revision 1.1  1996/10/10 04:28:19  steve
#  Add the ability the reset the ISE board from software,
#  using the pciconf package.
#

# --
# This program uses the pciconf driver to tell the BOOTPROM to start
# the program that has been downloaded. It does this by setting the
# BIST Start bit on the ATU portion of the i960RP

pciopen pci -r -w /dev/pciconf
pci select 0x8086 0x1960 0

set flags [pci get_word 0xe]

if { ! ($flags & 0x8000) } {
    puts "Download not completed. (BIST Capable bit not set.)\n"
    exit
}

pci set_word 0xe [expr {$flags | 0x4000}]
