/*
 * Copyright (c) 1996 Picture Elements, Inc.
 *    Stephen Williams (steve@picturel.com)
 *
 *    This source code is free software; you can redistribute it
 *    and/or modify it in source code form under the terms of the GNU
 *    Library General Public License as published by the Free Software
 *    Foundation; either version 2 of the License, or (at your option)
 *    any later version. In order to redistribute the software in
 *    binary form, you will need a Picture Elements Binary Software
 *    License.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU Library General Public License for more details.
 *
 *    You should have received a copy of the GNU Library General Public
 *    License along with this program; if not, write to the Free
 *    Software Foundation, Inc.,
 *    59 Temple Place - Suite 330
 *    Boston, MA 02111-1307, USA
 *
 *    You should also have recieved a copy of the Picture Elements
 *    Binary Software License offer along with the source. This offer
 *    allows you to obtain the right to redistribute the software in
 *    binary (compiled) form. If you have not received it, contact
 *    Picture Elements, Inc.,
 *    777 Panoramic Way
 *    Berkeley, CA 94704.
 */
#ident "$Id: main-sparc_linux.cc,v 1.1 1996/11/12 00:38:56 steve Exp $"
/*
 * $Log: main-sparc_linux.cc,v $
 * Revision 1.1  1996/11/12 00:38:56  steve
 *  Implement the sparc longjmp, fix the IEEEFP byte
 *  extraction for sparc, add the UCR_STACK_ATTRIBUTE
 *  definition and get the regress test to work for sparc_linux.
 *
 * Revision 1.2  1996/11/11 05:39:11  steve
 *  Get the target-specific main into a seperate function
 *  in order to do a stop on some targets, and make the
 *  thread test more synchronous.
 *
 * Revision 1.1  1996/11/10 23:38:52  steve
 *  Add a regression test to uCR.
 *
 */

# include  <ucr/ucr.h>
# include  <ucr/ISync.h>
# include  <stdio.h>
# include  <assert.h>
# include  <chips/LinuxIO.h>


LinuxIO host;
static FILE*init_stdout()
{
      return fopen("linux:stdout", "w");
}

void ucr_assert(const char*file, unsigned line)
{
      fprintf(stdout, "TEST FAILED at %s:%u\n", file, line);
      fflush(stdout);

      abort();
}

FILE*const stdout = init_stdout();

extern int main_comm();

main()
{
      return main_comm();
}
