/*
 * Copyright (c) 1996 Picture Elements, Inc.
 *    Stephen Williams
 *
 *    This source code is free software; you can redistribute it
 *    and/or modify it in source code form under the terms of the GNU
 *    Library General Public License as published by the Free Software
 *    Foundation; either version 2 of the License, or (at your option)
 *    any later version. In order to redistribute the software in
 *    binary form, you will need a Picture Elements Binary Software
 *    License.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU Library General Public License for more details.
 *
 *    You should have received a copy of the GNU Library General Public
 *    License along with this program; if not, write to the Free
 *    Software Foundation, Inc.,
 *    59 Temple Place - Suite 330
 *    Boston, MA 02111-1307, USA
 *
 *    You should also have recieved a copy of the Picture Elements
 *    Binary Software License offer along with the source. This offer
 *    allows you to obtain the right to redistribute the software in
 *    binary (compiled) form. If you have not received it, contact
 *    Picture Elements, Inc.,
 *    777 Panoramic Way
 *    Berkeley, CA 94704.
 */
#ident "$Id: main_comm.cc,v 1.2 1997/04/17 04:03:15 steve Exp $"
/*
 * $Log: main_comm.cc,v $
 * Revision 1.2  1997/04/17 04:03:15  steve
 *  Use word transfers in memset, if possible.
 *
 * Revision 1.1  1996/11/11 05:39:12  steve
 *  Get the target-specific main into a seperate function
 *  in order to do a stop on some targets, and make the
 *  thread test more synchronous.
 *
 * Revision 1.1  1996/11/10 23:38:51  steve
 *  Add a regression test to uCR.
 *
 */

/*
 * The actual main tends to be target specific, so keep it there. The
 * proper main calls this to actually do all the tests.
 */

# include  <stdio.h>

extern void memset_test(FILE*);
extern void setjmp_test(FILE*);
extern void ieee_functions(FILE*);
extern void basic_threads(FILE*);
extern void sprintf_test();


int main_comm()
{
      fprintf(stdout, "START TEST...\n");
      fflush(stdout);

      fprintf(stdout, "Test the memset function.\n");
      fflush(stdout);
      memset_test(stdout);

      fprintf(stdout, "Test the <setjmp.h> implementation.\n");
      fflush(stdout);
      setjmp_test(stdout);

      fprintf(stdout, "Test the IEEE 754 support library.\n");
      fflush(stdout);
      ieee_functions(stdout);

      fprintf(stdout, "Test the stdio string formatting.\n");
      fflush(stdout);
      sprintf_test();

      fprintf(stdout, "Test the basic thread support.\n");
      fflush(stdout);
      basic_threads(stdout);

      fprintf(stdout, "TEST COMPLETE\n");
      fflush(stdout);

      return 0;
}
