/*
 * Copyright (c) 1997 Picture Elements, Inc.
 *    Stephen Williams
 */
#ident "$Id: memset_test.cc,v 1.1 1997/04/17 04:03:15 steve Exp $"
/*
 * $Log: memset_test.cc,v $
 * Revision 1.1  1997/04/17 04:03:15  steve
 *  Use word transfers in memset, if possible.
 *
 */

# include  <assert.h>
# include  <stdio.h>
# include  <string.h>

void memset_test(FILE*)
{
      unsigned long alig[4];
      unsigned char*bp = (unsigned char*)alig;

	// Check that aligned set works
      memset(bp, 0xff, sizeof alig);
      for (unsigned idx = 0 ;  idx < sizeof alig ;  idx += 1)
	    assert( bp[idx] == 0xff );

	// Unaligned in the beginning...
      memset(bp+1, 0, (sizeof alig) - 1);
      assert( bp[0] == 0xff );
      assert( bp[1] == 0 );
      for (unsigned idx = 1 ;  idx < (sizeof alig) - 1 ;  idx += 1)
	    assert( bp[idx] == 0 );

      memset(bp, 0xff, sizeof alig);

	// Unaligned in the tail
      memset(bp, 0, (sizeof alig) - 1);
      assert( bp[sizeof alig - 1] == 0xff );
      for (unsigned idx = 0 ;  idx < (sizeof alig) - 1 ;  idx += 1)
	    assert( bp[idx] == 0 );

}
