#!/bin/sh
#
# Copyright (c) 1997 Picture Elements Inc.
#	Stephen Williams <steve@picturel.com>
#
#    This source code is free software; you can redistribute it
#    and/or modify it in source code form under the terms of the GNU
#    Library General Public License as published by the Free Software
#    Foundation; either version 2 of the License, or (at your option)
#    any later version. In order to redistribute the software in
#    binary form, you will need a Picture Elements Binary Software
#    License.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Library General Public License for more details.
#
#    You should have received a copy of the GNU Library General Public
#    License along with this program; if not, write to the Free
#    Software Foundation, Inc.,
#    59 Temple Place - Suite 330
#    Boston, MA 02111-1307, USA
#
#    You should also have recieved a copy of the Picture Elements
#    Binary Software License offer along with the source. This offer
#    allows you to obtain the right to redistribute the software in
#    binary (compiled) form. If you have not received it, contact
#    Picture Elements, Inc.,
#    777 Panoramic Way
#    Berkeley, CA 94704.
#
#ident "$Id: linux-ucr-gcc.sh,v 1.1 1997/12/04 15:27:22 steve Exp $"
#

#
# This script simulates on linux targets the compile/link behavior
# of a compiler configured for an embedded ucr target. This script
# takes all the parameters just like a normal gcc compiler, and translates
# to the native compiler.
#

ldtail=-lucr

parms=

for opt
do
    # This is the actual option I will put on the generated command
    # line. Normally, just use the one I'm processing.
    useopt=$opt

    case $opt
    in
	# If we are compiling, not linking, then remember to link in
	# the ucr library.
	-c) ldtail= ;;

	-static) useopt= ;;
    esac

    parms="$parms $useopt"
done

exec cc -static -nostartfiles $parms $ldtail

# $Log: linux-ucr-gcc.sh,v $
# Revision 1.1  1997/12/04 15:27:22  steve
#  Compile for virtual targets.
#
